/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgAddAudit.h: interface for the DlgAddAudit class.
//
//////////////////////////////////////////////////////////////////////

#ifndef DLGADDAUDIT_H
#define DLGADDAUDIT_H

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/dialog.h>

#include <stdio.h>
#include <ASN1/Asn1Logs.h>
#include <ASN1/Asn1Conf.h>


class DlgAddAudit: public wxDialog
{
public:
	DlgAddAudit(wxWindow * wParent, const mVector<unsigned long> & Types, const EntityAuditEntry & Audit);
	virtual ~DlgAddAudit();

	const EntityAuditEntry & GetAudit();

	void OnChkType(wxCommandEvent &event);
	void OnChkStatus(wxCommandEvent &event);
	void OnChkOpId(wxCommandEvent &event);
	void OnChkObject(wxCommandEvent &event);

	void OnOk(wxCommandEvent& event);
	void OnCancel(wxCommandEvent& event);
	bool IsOK();

private:
	bool m_IsOK;
	EntityAuditEntry m_Audit;
	DECLARE_EVENT_TABLE()
};

#endif
