/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgConfigureEntity.h: interface for the DlgConfigureEntity class.
//
//////////////////////////////////////////////////////////////////////

#ifndef DLGCONFIGUREENTITY_H
#define DLGCONFIGUREENTITY_H

#include <stdio.h>

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/dialog.h>

#include <ASN1/Asn1Conf.h>
#include <PkiClient.h>

#include "Error.h"


class DlgConfigureEntity: public wxDialog
{
public:
	DlgConfigureEntity(wxWindow * wParent, const PKI_CERT & entity_cert, PkiClient * ClientPki);
	virtual ~DlgConfigureEntity();
	void OnOk(wxCommandEvent& event);
	void OnCancel(wxCommandEvent& event);

protected:
	bool Init(int entity_type);
	EntityConfBody m_EntityConf;
	mVector<UsersGroup> m_Groups;

private:
	virtual bool SetConf() =0;
	virtual bool DisplayConf() =0;
	PKI_CERT m_entity_cert;
	PkiClient * m_ClientPki;
	bool m_IsOK;
};

#endif
