/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgConfigureRA.h: interface for the DlgConfigureRA class.
//
//////////////////////////////////////////////////////////////////////

#ifndef DLGCONFIGURERA_H
#define DLGCONFIGURERA_H

#include <stdio.h>

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/dialog.h>


#include "DlgConfigureEntity.h"


class DlgConfigureRA: public DlgConfigureEntity
{
public:
	DlgConfigureRA(wxWindow * wParent, const PKI_CERT & entity_cert, PkiClient * ClientPki);
	virtual ~DlgConfigureRA();
	void OnModifyDnValue(wxCommandEvent& event);
	void OnDelDnValue(wxCommandEvent& event);
	void OnAddDnValue(wxCommandEvent& event);
	void OnModifyPolValue(wxCommandEvent& event);
	void OnDelPolValue(wxCommandEvent& event);
	void OnAddPolValue(wxCommandEvent& event);
	void OnMoveDnUp(wxCommandEvent& event);
	void OnMoveDnDown(wxCommandEvent& event);
	void OnLdapImport(wxCommandEvent& event);
	void OnLdapAutoSynch(wxCommandEvent& event);
private:
	void LoadListPol();
	void LoadListDn();
	wxNotebook * Frames;
	wxListCtrl * m_listPol;
	wxListCtrl * m_listDn;
	wxImageList *m_imageListSmall;

	bool SetConf();
	bool DisplayConf();
	DECLARE_EVENT_TABLE()
};

#endif
