/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgGetPassword.cpp: implementation of the DlgGetPassword class.
//
//////////////////////////////////////////////////////////////////////

#include "DlgGetPassword.h"
#include "dlgs_wdr.h"
#include "clintl.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BEGIN_EVENT_TABLE(DlgGetPassword, wxDialog)
    EVT_BUTTON(IDC_OK, DlgGetPassword::OnOk)
    EVT_BUTTON(IDC_CANCEL, DlgGetPassword::OnCancel)
END_EVENT_TABLE()

DlgGetPassword::DlgGetPassword(const char * wxLabel, wxWindow * wParent):wxDialog(wParent, (wxWindowID)-1, wxLabel, wxDefaultPosition, wxDefaultSize, wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCAPTION)
{
	m_IsOK=false;
	DlgGetPassword_SetWindow(this);
	CenterOnScreen();
	ShowModal();
}

DlgGetPassword::~DlgGetPassword()
{
}

const mString & DlgGetPassword::GetPassword()
{
	return m_Password;
}

bool DlgGetPassword::IsOK()
{
	return m_IsOK;
}

void DlgGetPassword::OnOk(wxCommandEvent& event)
{
	if(!((wxTextCtrl *)FindWindow(IDC_PWD))->GetValue().Len())
		return;

	m_Password = ((wxTextCtrl *)FindWindow(IDC_PWD))->GetValue().GetData();
	m_IsOK = true;
	Close(TRUE);
}

void DlgGetPassword::OnCancel(wxCommandEvent& event)
{
	m_IsOK = false;
	Close(TRUE);
}
