/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgImportSignReq.h: interface for the DlgImportSignReq class.
//
//////////////////////////////////////////////////////////////////////

#ifndef DLGIMPORTSIGNREQ_H
#define DLGIMPORTSIGNREQ_H

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif
#include <wx/app.h>
#include <wx/imaglist.h>
#include <wx/listctrl.h>
#include <wx/treectrl.h>
#include <wx/frame.h>
#include <wx/timer.h>
#include <wx/tooltip.h>


#include <stdio.h>
#include <PkiClient.h>
#include "Error.h"

#include <ASN1/Asn1Entity.h>

#include "client.h"

class DlgImportSignReq: public wxDialog
{
public:
	DlgImportSignReq(wxWindow * wParent, PkiClient * ClientPki);
	virtual ~DlgImportSignReq();
	bool IsOK();
	void OnOpen(wxCommandEvent& event);
	void OnOk(wxCommandEvent& event);
	void OnCancel(wxCommandEvent &event);

private:
	bool m_IsOk;
	PkiClient * m_ClientPki;
	EntitySignatureReq req;
	DECLARE_EVENT_TABLE()
};

#endif
