/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgMessage.cpp: implementation of the DlgMessage class.
//
//////////////////////////////////////////////////////////////////////
#include "DlgMessage.h"
#include "dlgs_wdr.h"
#include "clintl.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


BEGIN_EVENT_TABLE(DlgMessage, wxDialog)
    EVT_CLOSE(DlgMessage::OnClose)
END_EVENT_TABLE()


DlgMessage::DlgMessage(wxWindow * wParent):wxDialog(wParent, (wxWindowID)-1, _("Please wait..."), wxDefaultPosition, wxDefaultSize, wxCAPTION)
{
	m_wParent = wParent;
	SetBackgroundColour(wxSystemSettings::GetSystemColour(wxSYS_COLOUR_3DFACE));
	DlgMessage_SetWindow(this);
}

DlgMessage::~DlgMessage()
{
	wHide();
}

void DlgMessage::wShow(const char * Message)
{
	((wxStaticText *)FindWindow(IDC_STATUS))->SetLabel(Message);
	CenterOnScreen();

	Show(TRUE);
	Enable(TRUE); // enable this window
	((wxStaticText *)FindWindow(IDC_STATUS))->Refresh();
	if(m_wParent)
		m_wParent->Enable(FALSE);

	NewpkiThread::Sleep(10);
}

void DlgMessage::wHide()
{
	Hide();
	if(m_wParent) m_wParent->Enable(TRUE);
}

void DlgMessage::OnClose(wxCloseEvent &event)
{
	event.SetCanVeto(true);
	event.Veto(true);
}
