/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/


// DlgProgress.h: interface for the DlgProgress class.
//
//////////////////////////////////////////////////////////////////////

#ifndef DLGPROGRESS_H
#define DLGPROGRESS_H

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

#include <wx/dialog.h>

      


/*!
	This class shows a progression
*/
class DlgProgress: public wxDialog
{
public:
	bool IsCanceled();
	void OnCancel(wxCommandEvent &event);
	void SetTitle(const char * Title);
	void OnClose(wxCloseEvent & event);
	DlgProgress(wxWindow * wParent);
	virtual ~DlgProgress();
	void wShow();
	void wHide();
	void SetValue(int Pos);
	void SetMax(int Max);
	
private:
	wxWindow * m_wParent;
	wxGauge * m_Progress;
	bool m_IsCanceled;
	DECLARE_EVENT_TABLE()
};

#endif
